<template>
  <section>
    <h2 class="fr-h6">{{ sectionTitle }}</h2>
    <AtomAlert
      v-if="error"
      :alert-type="AlertType.Error"
      :message="errorMessage"
    />
    <AtomLoader v-if="pending" />
    <ul
      v-else-if="relatives"
      class="information-list"
    >
      <template v-if="household">
        <li v-if="beneficiary?.family_situation">
          <span class="information-label">Situation familiale :</span>
          {{ FAMILY_SITUATION_OPTIONS.get(beneficiary?.family_situation) }}
        </li>
        <li v-if="beneficiary?.minor_children">
          {{ beneficiary?.minor_children }}
          <span class="information-label">{{ minorChildrenLabel }}</span>
        </li>
        <li v-if="beneficiary?.major_children">
          {{ beneficiary?.major_children }}
          <span class="information-label">{{ majorChildrenLabel }}</span>
        </li>
      </template>
      <li
        v-for="relative in relatives"
        :key="relative.id"
      >
        <span class="information-line">
          <NuxtLink
            v-if="household && relative.beneficiary"
            :to="Routes.Beneficiary(relative.beneficiary.id)"
            class="fr-link fr-icon-links-line fr-link--icon-left"
            target="_self"
            >{{ beneficiaryName(relative.beneficiary) }}</NuxtLink
          >
          <template v-else>{{ beneficiaryName(names(relative)) }}</template> -
          {{ typeLabel(relative) }}
        </span>
        <span
          v-if="hasCity(relative) || hasPhone(relative) || hasEmail(relative)"
          class="information-line"
        >
          {{ relativeContact(relative) }}
        </span>
        <span
          v-if="relative.caregiver"
          class="information-line fr-icon-success-line"
        >
          Aidant familial
        </span>
        <span
          v-if="relative.additional_information"
          class="information-line"
        >
          {{ relative.additional_information }}
        </span>
      </li>
    </ul>
  </section>
</template>

<script setup lang="ts">
  import { relativeContact } from '~~/utils'
  import { AlertType } from '~~/utils/constants/alert'
  import { FAMILY_SITUATION_OPTIONS } from '~/utils/constants/beneficiary'
  import { RELATIVE_TYPE_OPTIONS } from '~~/utils/constants/relative'
  import { beneficiaryName } from '~/utils/beneficiary'
  import { Routes } from '~/utils/routing/routes'
  import type { Relative } from '~/types/relative'
  import type { Beneficiary } from '~/types/beneficiary'

  const props = withDefaults(
    defineProps<{
      beneficiary?: Beneficiary | null
      relatives: Relative[] | null
      pending?: boolean
      error?: Error | null
      household?: boolean
    }>(),
    {
      beneficiary: null,
      pending: false,
      error: null,
      household: false
    }
  )

  const { minorChildrenLabel, majorChildrenLabel } = useBeneficiaryDetails(
    computed(() => props.beneficiary)
  )

  const sectionTitle = computed(() =>
    props.household ? 'Foyer fiscal' : 'Entourage'
  )
  const errorMessage = computed(() =>
    props.household
      ? "Les membres du foyer fiscal du bénéficiaire n'ont pas pu être chargés."
      : "Les membres de l'entourage du bénéficiaire n'ont pas pu être chargés."
  )

  function names({
    firstname,
    lastname
  }: Pick<Relative, 'firstname' | 'lastname'>) {
    return { firstname: firstname || '', usual_name: lastname || '' }
  }

  function typeLabel({ type }: Pick<Relative, 'type'>) {
    if (!type) return ''
    return RELATIVE_TYPE_OPTIONS.get(type) || type
  }

  function hasCity(relative: Relative) {
    if (relative.beneficiary) return false
    return relative.city
  }

  function hasPhone(relative: Relative) {
    if (relative.beneficiary) {
      return relative.beneficiary.phone_1 || relative.beneficiary.phone_2
    }
    return relative.phone
  }

  function hasEmail(relative: Relative) {
    if (relative.beneficiary) return relative.beneficiary.email
    return relative.email
  }
</script>
